diff -urNP Net-DNS-0.12/Changes Net-DNS-0.121/Changes
--- Net-DNS-0.12/Changes	Thu Oct  2 07:34:55 1997
+++ Net-DNS-0.121/Changes	Tue Sep 25 00:03:45 2001
@@ -1,6 +1,14 @@
 Revision history for Net::DNS
 =============================
 
+*** 0.121 24 Sep 2001
+
+Explicitly set local query IP address with
+Net::DNS::Resolver->LocalAddr($localip) .
+
+This patch was developed by jeff@lfcity.org and has been applied
+by Bernhard Graf <graf@augensalat.de>.
+
 *** 0.12  1 Oct 1997
 
 Implemented TCP queries.  UDP is still the default, but you can
diff -urNP Net-DNS-0.12/lib/Net/DNS/Resolver.pm Net-DNS-0.121/lib/Net/DNS/Resolver.pm
--- Net-DNS-0.12/lib/Net/DNS/Resolver.pm	Thu Oct  2 07:32:14 1997
+++ Net-DNS-0.121/lib/Net/DNS/Resolver.pm	Mon Sep 24 23:45:01 2001
@@ -98,6 +98,7 @@
 	"answerfrom"    => "",
 	"answersize"    => 0,
 	"tcp_timeout"   => 120,
+	"LocalAddr"	=> "0.0.0.0",
 );
 
 %global = (
@@ -542,6 +543,7 @@
 		my $sock = IO::Socket::INET->new(PeerAddr => $ns,
 				                 PeerPort => $self->{"port"},
 				                 Proto    => "tcp",
+						 LocalAddr => $self->{"LocalAddr"},
 						 Timeout  => $timeout);
 		$^W = $old_wflag;
 
@@ -637,6 +639,7 @@
 	@ns = grep { $_ } map {
 		IO::Socket::INET->new(PeerAddr => $_,
 				      PeerPort => $self->{"port"},
+				      LocalAddr => $self->{"LocalAddr"},
 				      Proto    => "udp");
 	} @{$self->{"nameservers"}};
 
@@ -751,6 +754,7 @@
 
 	my $sock = IO::Socket::INET->new(PeerAddr => $ns,
 					 PeerPort => $self->{"port"},
+					 LocalAddr => $self->{"LocalAddr"},
 					 Proto    => "udp");
 
 	unless ($sock) {
@@ -928,6 +932,7 @@
 
 	my $sock = new IO::Socket::INET(PeerAddr => $ns,
 					PeerPort => $self->{"port"},
+					LocalAddr => $self->{"LocalAddr"},
 					Proto    => "tcp",
 					Timeout  => $self->{"tcp_timeout"});
 
diff -urNP Net-DNS-0.12/lib/Net/DNS.pm Net-DNS-0.121/lib/Net/DNS.pm
--- Net-DNS-0.12/lib/Net/DNS.pm	Thu Oct  2 07:33:08 1997
+++ Net-DNS-0.121/lib/Net/DNS.pm	Tue Sep 25 00:16:56 2001
@@ -16,7 +16,7 @@
 	%rcodesbyval
 );
 
-$VERSION = "0.12";
+$VERSION = "0.121";
 
 use Net::DNS::Resolver;
 use Net::DNS::Packet;
@@ -134,7 +134,7 @@
 		@mxlist = sort { $a->preference <=> $b->preference } @mxlist;
 	}
 
-	return defined @mxlist ? @mxlist : ();
+	return @mxlist;
 }
 
 sub yxrrset {
